/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
	"fmt"
)

// HttpConnectorDtoRequest -
type HttpConnectorDtoRequest struct {
	ConnectorRequestDto *ConnectorRequestDto
}

// ConnectorRequestDtoAsHttpConnectorDtoRequest is a convenience function that returns ConnectorRequestDto wrapped in HttpConnectorDtoRequest
func ConnectorRequestDtoAsHttpConnectorDtoRequest(v *ConnectorRequestDto) HttpConnectorDtoRequest {
	return HttpConnectorDtoRequest{
		ConnectorRequestDto: v,
	}
}

// Unmarshal JSON data into one of the pointers in the struct
func (dst *HttpConnectorDtoRequest) UnmarshalJSON(data []byte) error {
	var err error
	// this object is nullable so check if the payload is null or empty string
	if string(data) == "" || string(data) == "{}" {
		return nil
	}

	match := 0
	// try to unmarshal data into ConnectorRequestDto
	err = newStrictDecoder(data).Decode(&dst.ConnectorRequestDto)
	if err == nil {
		jsonConnectorRequestDto, _ := json.Marshal(dst.ConnectorRequestDto)
		if string(jsonConnectorRequestDto) == "{}" { // empty struct
			dst.ConnectorRequestDto = nil
		} else {
			match++
		}
	} else {
		dst.ConnectorRequestDto = nil
	}

	if match > 1 { // more than 1 match
		// reset to nil
		dst.ConnectorRequestDto = nil

		return fmt.Errorf("data matches more than one schema in oneOf(HttpConnectorDtoRequest)")
	} else if match == 1 {
		return nil // exactly one match
	} else { // no match
		return fmt.Errorf("data failed to match schemas in oneOf(HttpConnectorDtoRequest)")
	}
}

// Marshal data from the first non-nil pointers in the struct to JSON
func (src HttpConnectorDtoRequest) MarshalJSON() ([]byte, error) {
	if src.ConnectorRequestDto != nil {
		return json.Marshal(&src.ConnectorRequestDto)
	}

	return nil, nil // no data in oneOf schemas
}

// Get the actual instance
func (obj *HttpConnectorDtoRequest) GetActualInstance() interface{} {
	if obj == nil {
		return nil
	}
	if obj.ConnectorRequestDto != nil {
		return obj.ConnectorRequestDto
	}

	// all schemas are nil
	return nil
}

type NullableHttpConnectorDtoRequest struct {
	value *HttpConnectorDtoRequest
	isSet bool
}

func (v NullableHttpConnectorDtoRequest) Get() *HttpConnectorDtoRequest {
	return v.value
}

func (v *NullableHttpConnectorDtoRequest) Set(val *HttpConnectorDtoRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableHttpConnectorDtoRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableHttpConnectorDtoRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableHttpConnectorDtoRequest(val *HttpConnectorDtoRequest) *NullableHttpConnectorDtoRequest {
	return &NullableHttpConnectorDtoRequest{value: val, isSet: true}
}

func (v NullableHttpConnectorDtoRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableHttpConnectorDtoRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
